//+------------------------------------------------------------------+
//|                                                       expert.mq5 |
//|                                           Copyright 2021, ernst. |
//|                                   https://www.mql5.com/en/pippod |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, ernst."
#property link      "https://www.mql5.com/en/pippod"
#property version   "1.00"
//--- input parameters
input double   LotSize=0.2;
input int      StartTime=9;
input int      StopTime=13;
//---
int EMA_21_M5=INVALID_HANDLE;
#include <Trade\Trade.mqh>
CTrade trade;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   if((EMA_21_M5 = iMA(_Symbol,_Period, 21, 0, MODE_EMA,PRICE_CLOSE))==INVALID_HANDLE)
      return(INIT_PARAMETERS_INCORRECT);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   IndicatorRelease(EMA_21_M5);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   datetime curDay=iTime(_Symbol,PERIOD_D1,0);
   datetime curTime=iTime(_Symbol,_Period,0);
   static datetime preDay=0,preTime=curTime;
   if(preDay==curDay || preTime==curTime)
      return;
//---
   int losses=HistoryDealGetStreak();
   if(losses==WRONG_VALUE)
     {
      preDay=curDay;
      return;
     }   
//---
   bool tradeTime=IsTradeTime(StartTime,StopTime);
   ulong ticket;
   ENUM_POSITION_TYPE type;
   PositionGetTicketType(ticket,type);
   ENUM_SIGNAL_TYPE signal=Signal();
//---
   if(tradeTime && type==WRONG_VALUE && signal==SIGNAL_BULL)
      if(trade.Buy(LotSize+LotSize*losses))
         preTime=curTime;
//---
   if(tradeTime && type==WRONG_VALUE && signal==SIGNAL_BEAR)
      if(trade.Sell(LotSize+LotSize*losses))
         preTime=curTime;
//---
   if(type==POSITION_TYPE_BUY && signal==SIGNAL_BEAR)
      trade.PositionClose(ticket);  
//---
   if(type==POSITION_TYPE_SELL && signal==SIGNAL_BULL)
      trade.PositionClose(ticket);   
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int HistoryDealGetStreak()
  {
//---
   HistorySelect(iTime(_Symbol,PERIOD_D1,0),TimeCurrent());
   int total=HistoryDealsTotal();
   ulong ticket;
   int losses=0;
   for(int i=total-1;i>=0;i--)
     {
      if((ticket=HistoryDealGetTicket(i))>0)
        { 
         if(HistoryDealGetDouble(ticket,DEAL_PROFIT)>0)
            return(WRONG_VALUE);
         losses++;
        }
     }  
//---
   return(losses);
  }   
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsTradeTime(int start_time,int stop_time)
  {
   MqlDateTime dt;
   TimeToStruct(TimeCurrent(),dt);
//---
   return(dt.hour>=start_time && dt.hour<stop_time);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void PositionGetTicketType(ulong& ticket,ENUM_POSITION_TYPE& type)
  {
   int total=PositionsTotal();
   if(total==0)
     {
      ticket=type=WRONG_VALUE; 
      return;
     }
   ticket=PositionGetTicket(0);
   type=(ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE); 
//---
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum ENUM_SIGNAL_TYPE
  {
   SIGNAL_NONE,
   SIGNAL_BULL,
   SIGNAL_BEAR
  };
//---
ENUM_SIGNAL_TYPE Signal()
  {
   double Ema_21[];
   MqlRates Rates[];
   ArraySetAsSeries(Ema_21,true);
   if(CopyBuffer(EMA_21_M5,0,1,1,Ema_21)==-1 || CopyRates(_Symbol,_Period,1,1,Rates)==-1)
      return(SIGNAL_NONE);
//---
   return((Ema_21[0]>Rates[0].open && Ema_21[0]<Rates[0].close)?SIGNAL_BULL:(Ema_21[0]<Rates[0].open && Ema_21[0]>Rates[0].close)?SIGNAL_BEAR:SIGNAL_NONE);
  }   
//+------------------------------------------------------------------+
